// UT2U1.uc --> BaseMutator fix.  06/20/13 by MrLoathsome. Major credits to Higor for help with the PostBeginPlay and U1GunFix stuff

class UT2U1 extends Mutator config(UT2U1);

var() config bool bU1GunFix;
var DeathMatchPlus MyGame;

function PostBeginPlay()
{
	local Mutator M;
	local Inventory Inv;
	local TorchFlame TF;

	MyGame = DeathMatchPlus(Level.Game);
	Super.PostBeginPlay();

	if ( DMMutator(Level.Game.BaseMutator) != none )
	{
		M = Level.Game.BaseMutator;
		if ( M.NextMutator == none )
			M.AddMutator(self);
		Level.Game.BaseMutator = M.nextMutator;
		M.Destroy();
	}
	else
	{
		For ( M=Level.Game.BaseMutator; M!=none; M=M.nextMutator )
		if ( DMMutator(M.nextMutator) != none )
		{
			M.nextMutator.LifeSpan = 1;
			M.nextMutator = M.nextMutator.nextMutator;
			break;
		}
	}

	if ( (Level.NetMode == NM_Standalone) && MyGame.bNoviceMode && MyGame.bRatedGame )
		forEach AllActors(class'Inventory', Inv)
		{
			Inv.RespawnTime *= (0.5 + 0.1 * MyGame.Difficulty);
		}
	forEach AllActors(class'TorchFlame', TF)
	{
		TF.NetUpdateFrequency = 0.5;
	}
	if (bU1GunFix) Spawn(class'MyWatcher');
}

function AddMutator(Mutator M)
{
	if ( M.IsA('DMMutator') )
		M.Destroy(); //NOPE
	else if ( M != self )
	Super.AddMutator(M);
}

function bool AlwaysKeep(Actor Other)
{
	local bool bTemp;

	if ( Other.IsA('StationaryPawn') )
		return true;

	if ( NextMutator != None )
		return ( NextMutator.AlwaysKeep(Other) );
	return false;
}

function ModifyPlayer(Pawn Other)
{
	if ( MyGame.bMegaSpeed )
	{
		Other.GroundSpeed *= 1.4;
		Other.WaterSpeed *= 1.4;
		Other.AirSpeed *= 1.4;
		Other.AccelRate *= 1.4;
	}

	Super.ModifyPlayer(Other);
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	bSuperRelevant = 1;
	if ( Other.IsA('StationaryPawn') )
		return true;
	if ( Other.IsA('Pickup') )
	{
		Pickup(Other).bAutoActivate = true;
		if ( Other.IsA('TournamentPickup') )
			return true;
	}
	bSuperRelevant = 0;
	return true;
}

defaultproperties
{
    bU1GunFix=False
}
